package cn.com.infosec.crypto.modes;

import cn.com.infosec.crypto.BlockCipher;
import cn.com.infosec.crypto.CipherParameters;
import cn.com.infosec.crypto.DataLengthException;

public class OpenPGPCFBBlockCipher implements BlockCipher {
   private byte[] IV;
   private byte[] FR;
   private byte[] FRE;
   private byte[] tmp;
   private BlockCipher cipher;
   private int count;
   private int blockSize;
   private boolean forEncryption;

   public OpenPGPCFBBlockCipher(BlockCipher cipher) {
      OpenPGPCFBBlockCipher var10000 = this;
      OpenPGPCFBBlockCipher var10001 = this;
      OpenPGPCFBBlockCipher var10002 = this;
      OpenPGPCFBBlockCipher var10003 = this;
      super();
      this.cipher = cipher;
      int var2;
      this.blockSize = var2 = cipher.getBlockSize();
      var10003.IV = new byte[var2];
      var10002.FR = new byte[var2];
      var10001.FRE = new byte[var2];
      var10000.tmp = new byte[var2];
   }

   private byte encryptByte(byte data, int blockOff) {
      return (byte)(this.FRE[blockOff] ^ data);
   }

   private int encryptBlock(byte[] in, int inOff, byte[] out, int outOff) {
      int var5;
      if (inOff + (var5 = this.blockSize) <= in.length) {
         if (outOff + var5 > out.length) {
            throw new DataLengthException("output buffer too short");
         } else {
            int var6;
            byte var7;
            int in1;
            byte[] inOff1;
            int out1;
            byte[] var12;
            byte[] var13;
            if ((var6 = this.count) > var5) {
               byte[] var10002 = this.FR;
               int var10006 = var5;
               var5 -= 2;
               byte var11 = in[inOff];
               out[outOff] = var11 = this.encryptByte(var11, var10006 - 2);
               var10002[var5] = var11;
               byte[] var10001 = this.FR;
               int var10004 = var5 = this.blockSize;
               --var5;
               var6 = outOff + 1;
               var7 = in[inOff + 1];
               var7 = this.encryptByte(var7, var10004 - 1);
               out[var6] = var7;
               var10001[var5] = var7;
               var12 = this.FR;
               var13 = this.FRE;
               this.cipher.processBlock(var12, 0, var13, 0);

               for(var5 = 2; var5 < (var6 = this.blockSize); ++var5) {
                  var6 = outOff + var5;
                  var7 = in[inOff + var5];
                  out[var6] = this.encryptByte(var7, var5 - 2);
               }

               in1 = outOff + 2;
               inOff1 = this.FR;
               out1 = var6 - 2;
               System.arraycopy(out, in1, inOff1, 0, out1);
            } else if (var6 == 0) {
               var12 = this.FR;
               var13 = this.FRE;
               this.cipher.processBlock(var12, 0, var13, 0);

               for(var5 = 0; var5 < (var6 = this.blockSize); ++var5) {
                  var6 = outOff + var5;
                  out[var6] = this.encryptByte(in[inOff + var5], var5);
               }

               System.arraycopy(out, outOff, this.FR, 0, var6);
               this.count += this.blockSize;
            } else if (var6 == var5) {
               var12 = this.FR;
               var13 = this.FRE;
               this.cipher.processBlock(var12, 0, var13, 0);
               out[outOff] = this.encryptByte(in[inOff], 0);
               var5 = outOff + 1;
               out[var5] = this.encryptByte(in[inOff + 1], 1);
               byte[] var10005 = this.FR;
               var5 = this.blockSize - 2;
               System.arraycopy(var10005, 2, var10005, 0, var5);
               var12 = this.FR;
               System.arraycopy(out, outOff, var12, this.blockSize - 2, 2);
               var12 = this.FR;
               var13 = this.FRE;
               this.cipher.processBlock(var12, 0, var13, 0);

               for(var5 = 2; var5 < (var6 = this.blockSize); ++var5) {
                  var6 = outOff + var5;
                  var7 = in[inOff + var5];
                  out[var6] = this.encryptByte(var7, var5 - 2);
               }

               in1 = outOff + 2;
               inOff1 = this.FR;
               out1 = var6 - 2;
               System.arraycopy(out, in1, inOff1, 0, out1);
               this.count += this.blockSize;
            }

            return this.blockSize;
         }
      } else {
         throw new DataLengthException("input buffer too short");
      }
   }

   private int decryptBlock(byte[] in, int inOff, byte[] out, int outOff) {
      int var5;
      if (inOff + (var5 = this.blockSize) <= in.length) {
         if (outOff + var5 > out.length) {
            throw new DataLengthException("output buffer too short");
         } else {
            int var6;
            if ((var6 = this.count) > var5) {
               System.arraycopy(in, inOff, this.tmp, 0, var5);
               out[outOff] = this.encryptByte(this.tmp[0], this.blockSize - 2);
               int in1 = outOff + 1;
               out[in1] = this.encryptByte(this.tmp[1], this.blockSize - 1);
               in = this.FR;
               inOff = this.blockSize - 2;
               System.arraycopy(this.tmp, 0, in, inOff, 2);
               in = this.FR;
               byte[] inOff1 = this.FRE;
               this.cipher.processBlock(in, 0, inOff1, 0);

               for(in1 = 2; in1 < (inOff = this.blockSize); ++in1) {
                  inOff = outOff + in1;
                  byte var12 = this.tmp[in1];
                  out[inOff] = this.encryptByte(var12, in1 - 2);
               }

               in = this.FR;
               inOff -= 2;
               System.arraycopy(this.tmp, 2, in, 0, inOff);
            } else {
               byte[] var13;
               if (var6 == 0) {
                  byte[] outOff1 = this.FR;
                  var13 = this.FRE;
                  this.cipher.processBlock(outOff1, 0, var13, 0);

                  for(outOff = 0; outOff < (var5 = this.blockSize); ++outOff) {
                     this.FR[outOff] = in[var5 = inOff + outOff];
                     out[outOff] = this.encryptByte(in[var5], outOff);
                  }

                  this.count += var5;
               } else if (var6 == var5) {
                  System.arraycopy(in, inOff, this.tmp, 0, var5);
                  var13 = this.FR;
                  byte[] var14 = this.FRE;
                  this.cipher.processBlock(var13, 0, var14, 0);
                  out[outOff] = this.encryptByte(this.tmp[0], 0);
                  var5 = outOff + 1;
                  out[var5] = this.encryptByte(this.tmp[1], 1);
                  byte[] var10002 = this.FR;
                  var5 = this.blockSize - 2;
                  System.arraycopy(var10002, 2, var10002, 0, var5);
                  byte[] var10001 = var13 = this.FR;
                  int var7 = (var6 = this.blockSize) - 2;
                  byte[] var8;
                  var10002 = var8 = this.tmp;
                  var13[var7] = var8[0];
                  --var6;
                  var10001[var6] = var10002[1];
                  this.cipher.processBlock(var13, 0, this.FRE, 0);

                  for(var5 = 2; var5 < (var6 = this.blockSize); ++var5) {
                     var6 = var5 - 2;
                     this.FR[var6] = in[var7 = inOff + var5];
                     int var15 = outOff + var5;
                     out[var15] = this.encryptByte(in[var7], var6);
                  }

                  this.count += var6;
               }
            }

            return this.blockSize;
         }
      } else {
         throw new DataLengthException("input buffer too short");
      }
   }

   public BlockCipher getUnderlyingCipher() {
      return this.cipher;
   }

   public String getAlgorithmName() {
      return this.cipher.getAlgorithmName() + "/OpenPGPCFB";
   }

   public int getBlockSize() {
      return this.cipher.getBlockSize();
   }

   public int processBlock(byte[] in, int inOff, byte[] out, int outOff) {
      return this.forEncryption ? this.encryptBlock(in, inOff, out, outOff) : this.decryptBlock(in, inOff, out, outOff);
   }

   public void reset() {
      OpenPGPCFBBlockCipher var10000 = this;
      this.count = 0;
      byte[] var10001 = this.IV;
      byte[] var2;
      int var1 = (var2 = this.FR).length;
      System.arraycopy(var10001, 0, var2, 0, var1);
      var10000.cipher.reset();
   }

   public void init(boolean forEncryption, CipherParameters params) {
      this.forEncryption = forEncryption;
      this.reset();
      this.cipher.init(true, params);
   }
}
